package buildadvancer;

/**
 *
 * @author vince
 */
import com.hullabaloo.gui.createFileChooser;
import java.awt.BorderLayout;
import java.awt.Dimension;
import java.awt.GridLayout;
import java.awt.Toolkit;
import java.awt.datatransfer.Clipboard;
import java.awt.datatransfer.StringSelection;
import java.awt.event.ActionEvent;
import java.awt.event.MouseAdapter;
import java.awt.event.MouseEvent;
import java.io.BufferedWriter;
import java.io.File;
import java.io.FileInputStream;
import java.io.FileOutputStream;
import java.io.FileWriter;
import java.io.IOException;
import java.nio.file.Files;
import java.nio.file.Path;
import java.nio.file.Paths;
import java.text.SimpleDateFormat;
import java.time.LocalDateTime;
import java.time.format.DateTimeFormatter;
import java.util.ArrayList;
import java.util.Calendar;
import java.util.List;
import java.util.logging.Level;
import java.util.logging.Logger;
import java.util.zip.ZipEntry;
import java.util.zip.ZipOutputStream;
import javax.swing.Icon;
import javax.swing.ImageIcon;
import javax.swing.JButton;
import javax.swing.JFrame;
import javax.swing.JMenuItem;
import javax.swing.JOptionPane;
import javax.swing.JPanel;
import javax.swing.JPopupMenu;
import javax.swing.JScrollPane;
import javax.swing.JTextArea;
import javax.swing.SwingUtilities;
import javax.swing.UIManager;
import javax.swing.UnsupportedLookAndFeelException;
import javax.swing.filechooser.FileSystemView;

public class BuildAdvancer {

    public static JFrame window;
    public static JTextArea outputLog;
    public static JButton zipFolder;
    public static JButton choose_Input;
    public static JButton choose_Output;
    public static JPanel choose_panel;
    public static JScrollPane scroll;
    public static GridLayout panel_layout;
    public static JMenuItem copyOutput;
    public static JMenuItem saveOutput;

    public static int folderContents;
    public static int totalZipped = 0;

    private List<String> fileList;
    private DateTimeFormatter buildStamp_Format = DateTimeFormatter.ofPattern("MM-dd-yyyy (HH-mm-ss)");
    private LocalDateTime now = LocalDateTime.now();
    private String buildStamp = buildStamp_Format.format(now);
    private final String programDir = System.getProperty("user.dir");
    private static String SOURCE_FOLDER = "C:\\Users\\vince\\Desktop\\Folders\\Unreal_Project\\ITGM_ALIQUO";
    private static String OUTPUT_FOLDER = "C:\\Users\\vince\\Desktop\\Folders\\Unreal_Project";
    private static String OUTPUT_ZIP_FILE = "Build.zip";

    public BuildAdvancer() {
        fileList = new ArrayList< String>();
    }

    public static void main(String[] args) throws IOException, ClassNotFoundException, InstantiationException, IllegalAccessException, UnsupportedLookAndFeelException {
        UIManager.setLookAndFeel(UIManager.getSystemLookAndFeelClassName());
        /*Component Setup*/
        outputLog = new JTextArea();
        scroll = new JScrollPane();
        zipFolder = new JButton("Zip Build");
        choose_panel = new JPanel();
        panel_layout = new GridLayout(0, 2);
        copyOutput = new JMenuItem("Copy to clipboard");
        saveOutput = new JMenuItem("Save output to file");
        choose_panel.setLayout(panel_layout);
        choose_Input = new JButton("Select Source", new ImageIcon("Images/open.png"));
        File systemZipIcon = new File("Images/ForIcon.zip");
        Icon ico = FileSystemView.getFileSystemView().getSystemIcon(new File(systemZipIcon.getAbsolutePath()));
        zipFolder.setIcon(ico);
        choose_Output = new JButton("Select Output Location");
        choose_panel.add(BorderLayout.WEST, choose_Input);
        choose_panel.add(BorderLayout.EAST, choose_Output);
        choose_Output.setEnabled(false);
        zipFolder.setEnabled(false);
        copyOutput.setEnabled(false);
        saveOutput.setEnabled(false);
        BuildAdvancer percentageCounter = new BuildAdvancer();
        percentageCounter.getFile(SOURCE_FOLDER);

        /*Window Setup*/
        window = new JFrame("Build Advancer");
        outputLog.setEditable(false);
        scroll = new JScrollPane(outputLog, JScrollPane.VERTICAL_SCROLLBAR_AS_NEEDED,
                JScrollPane.HORIZONTAL_SCROLLBAR_AS_NEEDED);
        window.setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
        window.setIconImage(Toolkit.getDefaultToolkit().getImage("images/open.png")); //set the program icon to open.png
        window.add(BorderLayout.NORTH, choose_panel);
        window.add(BorderLayout.SOUTH, zipFolder);
        window.add(BorderLayout.CENTER, scroll);
        window.setMinimumSize(new Dimension(500, 300));
        window.setLocationRelativeTo(null);
        window.setResizable(true);
        window.setVisible(true);

        /*Input and output components*/
        choose_Input.addActionListener((ActionEvent e) -> {
            createFileChooser fc = new createFileChooser("Select a directory to zip", "DIRECTORIES_ONLY");
            SOURCE_FOLDER = fc.getSelection();
            String parentName = new File(SOURCE_FOLDER).getName();
            OUTPUT_ZIP_FILE = parentName + ".zip";
            choose_Output.setEnabled(true);
            outputLog.append("Selected directory '" + parentName + "' to Zip" + "\n");
            copyOutput.setEnabled(true);
            saveOutput.setEnabled(true);
        });

        choose_Output.addActionListener((ActionEvent e) -> {
            createFileChooser fc = new createFileChooser("Select an output directory", "DIRECTORIES_ONLY");
            OUTPUT_FOLDER = fc.getSelection();
            zipFolder.setEnabled(true);
            String parentName = new File(SOURCE_FOLDER).getName();
            outputLog.append("Selected output directory " + fc.getSelection() + "\\" + parentName + ".zip" + "\n");
            System.out.println(OUTPUT_FOLDER);
        });
        /*Popup Menu for output log*/
        saveOutput.addActionListener((ActionEvent e) -> {
            String timeStamp = new SimpleDateFormat("MM/dd/yyyy_HH:mm:ss").format(Calendar.getInstance().getTime());
            String timeStamp2 = new SimpleDateFormat("MM-dd-yyyy_HH").format(Calendar.getInstance().getTime());
            createFileChooser fc = new createFileChooser("Select an output directory", "DIRECTORIES_ONLY");
            BufferedWriter out = null;
            try {
                out = new BufferedWriter(new FileWriter(fc.getSelection() + "/" + timeStamp2 + "- Output Log.txt"));
            } catch (IOException ex) {
                Logger.getLogger(BuildAdvancer.class.getName()).log(Level.SEVERE, null, ex);
            }
            try {
                outputLog.write(out);
                out.flush();
                out.close();
            } catch (IOException ex) {
                Logger.getLogger(BuildAdvancer.class.getName()).log(Level.SEVERE, null, ex);
            }
        });
        copyOutput.addActionListener((ActionEvent e) -> {
            try {
                StringSelection stringSelection = new StringSelection(outputLog.getText());
                Clipboard clpbrd = Toolkit.getDefaultToolkit().getSystemClipboard();
                clpbrd.setContents(stringSelection, null);
            } catch (Exception ex) {
                System.out.println("Nothing");
            }
        });
        outputLog.addMouseListener(new MouseAdapter() {
            @Override
            public void mouseReleased(MouseEvent e) {
                if (SwingUtilities.isRightMouseButton(e)) {
                    JPopupMenu popup = new JPopupMenu();
                    popup.add(saveOutput);
                    popup.add(copyOutput);
                    popup.show(e.getComponent(), e.getX(), e.getY());
                }
            }
        });
        /*End of Popup Menu for output log*/
        zipFolder.addActionListener((ActionEvent e) -> {
            BuildAdvancer appZip = new BuildAdvancer();
            appZip.generateFileList(new File(SOURCE_FOLDER));
            appZip.zipIt(OUTPUT_ZIP_FILE);
            try {
                appZip.moveFile();
            } catch (IOException ex) {
                Logger.getLogger(BuildAdvancer.class.getName()).log(Level.SEVERE, null, ex);
            }
            totalZipped = 0;
            window.setTitle("BuildAdvancer");
        });
    }

    public void zipIt(String zipFile) {
        outputLog.append("Attemptig to zip " + folderContents + " files");
        byte[] buffer = new byte[1024];
        String source = new File(SOURCE_FOLDER).getName();
        FileOutputStream fos = null;
        ZipOutputStream zos = null;
        try {
            fos = new FileOutputStream(zipFile);
            zos = new ZipOutputStream(fos);

            outputLog.append("Output to Zip : " + zipFile + "\n");
            FileInputStream in = null;

            for (String file : this.fileList) {
                outputLog.append("File Added : " + file + "\n");
                totalZipped++;
                double percentageZipped = 100.0 / folderContents;
                percentageZipped = percentageZipped * totalZipped;
                window.setTitle("Build Advancer" + " (" + (int) percentageZipped + "%)");
                ZipEntry ze = new ZipEntry(source + File.separator + file);
                zos.putNextEntry(ze);
                try {
                    in = new FileInputStream(SOURCE_FOLDER + File.separator + file);
                    int len;
                    while ((len = in.read(buffer)) > 0) {
                        zos.write(buffer, 0, len);
                    }
                } finally {
                    in.close();
                }
            }
            zos.closeEntry();
            outputLog.append("Folder successfully compressed" + "\n");

        } catch (IOException ex) {
            ex.printStackTrace();
        } finally {
            try {
                zos.close();
            } catch (IOException e) {
                e.printStackTrace();
            }
        }
    }

    public void generateFileList(File node) {
        if (node.isFile()) {
            fileList.add(generateZipEntry(node.toString()));
        }

        if (node.isDirectory()) {
            String[] subNote = node.list();
            for (String filename : subNote) {
                generateFileList(new File(node, filename));
            }
        }
    }

    public void moveFile() throws IOException {
        Path temp = Files.move(Paths.get(programDir + "\\" + OUTPUT_ZIP_FILE),
                Paths.get(SOURCE_FOLDER + "\\" + OUTPUT_ZIP_FILE));
        if (temp != null) {
            outputLog.append("File successfully moved to source directory" + "\n");
        } else {
            outputLog.append("Unable to relocate file to source directory" + "\n");
        }
        File file = new File(SOURCE_FOLDER + "\\" + OUTPUT_ZIP_FILE);
        String parentName = new File(SOURCE_FOLDER).getName();
        File file2 = new File(OUTPUT_FOLDER + "\\" + parentName + "_" + buildStamp + ".zip");
        System.out.println(file2);
        if (file2.exists()) {
            throw new java.io.IOException("file exists");
        }
        boolean success = file.renameTo(file2);
        JOptionPane.showMessageDialog(null, "Successfully zipped the folder '" + parentName + ".zip'");
        window.setTitle("Build Advancer");
        if (!success) {

        }
    }

    private void getFile(String dirPath) {
        File f = new File(dirPath);
        File[] files = f.listFiles();

        if (files != null) {
            for (int i = 0; i < files.length; i++) {
                folderContents++;
                File file = files[i];

                if (file.isDirectory()) {
                    getFile(file.getAbsolutePath());
                }
            }
        }
    }

    private String generateZipEntry(String file) {
        return file.substring(SOURCE_FOLDER.length() + 1, file.length());
    }
}
